import { Injectable } from '@angular/core';

import {
    HttpClient,
    HttpParams
} from '@angular/common/http';

import { Observable } from 'rxjs/Observable';

import { map } from 'rxjs/operators';

import { GiftedSub } from '../models/giftedsub';


@Injectable()
export class GiftedSubsService {
    constructor(private http: HttpClient) { }

    findGiftedSubs(
        filter = '', sortBy = 'time', sortOrder = 'desc',
        pageNumber = 0, pageSize = 20): Observable<any> {

        return this.http.get('/twitch-subs/api/gifted-subs', {
            observe: 'response',
            params: new HttpParams()
                .set('filter', filter)
                .set('sort_by', sortBy)
                .set('sort_order', sortOrder)
                .set('page_number', pageNumber.toString())
                .set('page_size', pageSize.toString())
        }).pipe(
            map(res => ({
                giftedSubs: <GiftedSub[]>res.body,
                totalCount: parseInt(res.headers.get('X-Total-Count'))
            }))
        );
    }
}
