import {
    Pipe,
    PipeTransform
} from '@angular/core';

import * as linkify from 'linkifyjs';


@Pipe({
    name: 'splitmessage'
})
export class SplitMessagePipe implements PipeTransform {

    transform(emotes: any[], message: string): any[] {
        if (emotes.length == 0) {
            return [];
        }

        let exps = emotes.map(
            (emote: any) => emote.title.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&')
        );

        let regexp = RegExp('(' + exps.join('|') + ')');

        let options = new linkify.options.Options();

        let result = [];

        for (let token of linkify.tokenize(message)) {
            if (token.isLink) {
                result.push(options.resolve(token));
                continue;
            }

            for (let part of token.toString().split(regexp)) {
                let e = emotes.filter((emote: any) => emote.title == part);

                if (e.length > 0) {
                    result.push(e[0]);
                } else {
                    result.push(part);
                }
            }
        }

        return result;
    }
}
